Index: uspace/lib/inet/include/inet/addr.h
===================================================================
--- uspace/lib/inet/include/inet/addr.h	(revision ec7902df3bea37028cfd215b507c5248f4e054dd)
+++ uspace/lib/inet/include/inet/addr.h	(revision f05edcb84588b46065563dbdd0d0e78b9b4fb2b6)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2013 Jiri Svoboda
+ * Copyright (c) 2021 Jiri Svoboda
  * All rights reserved.
  *
@@ -40,5 +40,11 @@
 
 typedef uint32_t addr32_t;
-typedef uint8_t addr48_t[6];
+
+#define ETH_ADDR_SIZE 6
+
+typedef struct {
+	uint8_t b[ETH_ADDR_SIZE];
+} addr48_t;
+
 typedef uint8_t addr128_t[16];
 
@@ -80,11 +86,11 @@
 extern const addr48_t addr48_broadcast;
 
-extern void addr48(const addr48_t, addr48_t);
+extern void addr48(const addr48_t *, addr48_t *);
 extern void addr128(const addr128_t, addr128_t);
 
-extern int addr48_compare(const addr48_t, const addr48_t);
+extern int addr48_compare(const addr48_t *, const addr48_t *);
 extern int addr128_compare(const addr128_t, const addr128_t);
 
-extern void addr48_solicited_node(const addr128_t, addr48_t);
+extern void addr48_solicited_node(const addr128_t, addr48_t *);
 
 extern void host2addr128_t_be(const addr128_t, addr128_t);
Index: uspace/lib/inet/include/inet/eth_addr.h
===================================================================
--- uspace/lib/inet/include/inet/eth_addr.h	(revision f05edcb84588b46065563dbdd0d0e78b9b4fb2b6)
+++ uspace/lib/inet/include/inet/eth_addr.h	(revision f05edcb84588b46065563dbdd0d0e78b9b4fb2b6)
@@ -0,0 +1,49 @@
+/*
+ * Copyright (c) 2021 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup inet
+ * @{
+ */
+/**
+ * @file
+ * @brief
+ */
+
+#ifndef _LIBC_INET_ETH_ADDR_H_
+#define _LIBC_INET_ETH_ADDR_H_
+
+// XXX Move addr48 here
+#include <inet/addr.h>
+
+extern void mac48_encode(addr48_t *, void *);
+extern void mac48_decode(const void *, addr48_t *);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/inet/include/inet/iplink.h
===================================================================
--- uspace/lib/inet/include/inet/iplink.h	(revision ec7902df3bea37028cfd215b507c5248f4e054dd)
+++ uspace/lib/inet/include/inet/iplink.h	(revision f05edcb84588b46065563dbdd0d0e78b9b4fb2b6)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2012 Jiri Svoboda
+ * Copyright (c) 2021 Jiri Svoboda
  * All rights reserved.
  *
@@ -79,5 +79,5 @@
 typedef struct iplink_ev_ops {
 	errno_t (*recv)(iplink_t *, iplink_recv_sdu_t *, ip_ver_t);
-	errno_t (*change_addr)(iplink_t *, addr48_t);
+	errno_t (*change_addr)(iplink_t *, addr48_t *);
 } iplink_ev_ops_t;
 
@@ -90,5 +90,5 @@
 extern errno_t iplink_get_mtu(iplink_t *, size_t *);
 extern errno_t iplink_get_mac48(iplink_t *, addr48_t *);
-extern errno_t iplink_set_mac48(iplink_t *, addr48_t);
+extern errno_t iplink_set_mac48(iplink_t *, addr48_t *);
 extern void *iplink_get_userptr(iplink_t *);
 
